
print("Setting up AFG listeners");

# Store listeners here:
var afg={};
afg.adf = [];
afg.ap = [];
afg.enc = [];


# Autopilot
# Based on: fgdata/Aircraft/c172p/Models/Interior/Panel/Instruments/kap140/KAP140TwoAxisAlt.xml

# btn: property node of current state (from Arduino)
# state: property node of previous state
# If these are different, the button has been pressed or depressed => do some action.

var AFGclickAP = func() {
    var btn = "/Arduino/controls/autopilot/btn-on";
    var state = "/Arduino/controls/autopilot/btn-on-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("AFG click AP on/off");
        # press button and make sound:
        kap140.apButton(); c172p.click("kap140");
        setprop(state, 1);
        fgcommand("property-toggle", {'property': '/instrumentation/ap-btn'});
    }
    else if (curval == 0 and wasval != 0) {
        setprop(state, 0);
        fgcommand("property-toggle", {'property': '/instrumentation/ap-btn'});
    }
}


var AFGclickAPup = func() {
    var btn = "/Arduino/controls/autopilot/btn-up";
    var state = "/Arduino/controls/autopilot/btn-up-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("AFG click AP up");
        kap140.upButton(); c172p.click("kap140");
        setprop(state, 1);
        fgcommand("property-toggle", {'property': '/instrumentation/up-btn'});
    }
    else if (curval == 0 and wasval != 0) {
         setprop(state, 0);
        fgcommand("property-toggle", {'property': '/instrumentation/up-btn'});
    }
}

var AFGclickAPhdg = func() {
    var btn = "/Arduino/controls/autopilot/btn-hdg";
    var state = "/Arduino/controls/autopilot/btn-hdg-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("AFG click AP hdg");
        kap140.hdgButton(); c172p.click("kap140");
        setprop(state, 1);
        fgcommand("property-toggle", {'property': '/instrumentation/hdg-btn'});
    }
    else if (curval == 0 and wasval != 0) {
        setprop(state, 0);
        fgcommand("property-toggle", {'property': '/instrumentation/hdg-btn'});
    }
}

var AFGclickAPdown = func() {
    var btn = "/Arduino/controls/autopilot/btn-down";
    var state = "/Arduino/controls/autopilot/btn-down-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("AFG click AP down");
        kap140.downButton(); c172p.click("kap140");
        setprop(state, 1);
        fgcommand("property-toggle", {'property': '/instrumentation/dn-btn'});
    }
    else if (curval == 0 and wasval != 0) {
        setprop(state, 0);
        fgcommand("property-toggle", {'property': '/instrumentation/dn-btn'});
    }
}


append(afg.ap, setlistener("/Arduino/controls/autopilot/btn-on", AFGclickAP, 0, 0) );
append(afg.ap, setlistener("/Arduino/controls/autopilot/btn-hdg", AFGclickAPhdg, 0, 0) );
append(afg.ap, setlistener("/Arduino/controls/autopilot/btn-up", AFGclickAPup, 0, 0) );
append(afg.ap, setlistener("/Arduino/controls/autopilot/btn-down", AFGclickAPdown, 0, 0) );



# ADF
# Based on: fgdata/Aircraft/Generic/kr87.xml

var ADFclickADF = func() {
    var btn = "/Arduino/controls/adf/adf";
    var state = "/Arduino/controls/adf/adf-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("ADF click ADF: ", systime());
        fgcommand("property-toggle", {'property': '/instrumentation/adf/adf-btn'});
        c172p.click("kr87-adf");
        setprop(state, 1);
    }
    else if (curval == 0 and wasval != 0) {
        fgcommand("property-toggle", {'property': '/instrumentation/adf/adf-btn'});
        setprop(state, 0);
    }
}

var ADFclickBFO = func() {
    var btn = "/Arduino/controls/adf/bfo";
    var state = "/Arduino/controls/adf/bfo-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("ADF click BFO: ", systime());
        fgcommand("property-toggle", {'property': '/instrumentation/adf/bfo-btn'});
        c172p.click("kr87-adf");
        setprop(state, 1);
    }
    else if (curval == 0 and wasval != 0) {
        fgcommand("property-toggle", {'property': '/instrumentation/adf/bfo-btn'});
        setprop(state, 0);
    }
}

var ADFclickFRQ = func() {
    var btn = "/Arduino/controls/adf/frq";
    var state = "/Arduino/controls/adf/frq-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("ADF click FRQ: ", systime());
        fgcommand("property-toggle", {'property': '/instrumentation/adf/frq-btn'});
        fgcommand("property-assign", {'property': '/instrumentation/adf/frq-btn', 'value': 1});
        if (getprop("/instrumentation/adf/display-mode") == 0) {
            fgcommand("property-swap", {'property': ['/instrumentation/adf/frequencies/selected-khz', '/instrumentation/adf/frequencies/standby-khz']});
            print("freq swap");
        }
        fgcommand("property-assign", {'property': '/instrumentation/adf/display-mode', 'value': 0});
        c172p.click("kr87-adf");
        setprop(state, 1);
    }
    else if (curval == 0 and wasval != 0) {
        fgcommand("property-assign", {'property': '/instrumentation/adf/frq-btn', 'value': 0});
        setprop(state, 0);
    }
}

var ADFclickFLT = func() {
    var btn = "/Arduino/controls/adf/flt";
    var state = "/Arduino/controls/adf/flt-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("ADF click FLT: ", systime());
        fgcommand("property-assign", {'property': '/instrumentation/adf/flt-btn', 'value': 1});
        fgcommand("property-adjust", {'property': '/instrumentation/adf/display-mode', 'step': 1, 'min': 1, 'max': 3, 'wrap': 'true'});
        c172p.click("kr87-adf");
        setprop(state, 1);
    }
    else if (curval == 0 and wasval != 0) {
        fgcommand("property-assign", {'property': '/instrumentation/adf/flt-btn', 'value': 0});
        setprop(state, 0);
    }
}

var ADFclickSET = func() {
    var btn = "/Arduino/controls/adf/set";
    var state = "/Arduino/controls/adf/set-state";
    var curval = getprop(btn);
    var wasval = getprop(state);
    if (curval == 1 and wasval != 1) {
        print("ADF click SET: ", systime());
        fgcommand("property-assign", {'property': '/instrumentation/adf/set-btn', 'value': 1});
        c172p.click("kr87-adf");
        setprop(state, 1);
    }
    else if (curval == 0 and wasval != 0) {
        fgcommand("property-assign", {'property': '/instrumentation/adf/set-btn', 'value': 0});
        setprop(state, 0);
    }
}



append(afg.adf, setlistener("/Arduino/controls/adf/adf", ADFclickADF, 0, 0) );
append(afg.adf, setlistener("/Arduino/controls/adf/frq", ADFclickFRQ, 0, 0) );
append(afg.adf, setlistener("/Arduino/controls/adf/flt", ADFclickFLT, 0, 0) );
append(afg.adf, setlistener("/Arduino/controls/adf/set", ADFclickSET, 0, 0) );
append(afg.adf, setlistener("/Arduino/controls/adf/bfo", ADFclickBFO, 0, 0) );


# Encoder and encoder-like controlled properties

var AFGrudder = func() {
    var increment = 0.005;
    var change = getprop("/Arduino/controls/flight/rudder");
    if (change == 0)
        return;
    fgcommand("property-adjust", {'property': '/controls/flight/rudder', 'step': increment*change, 'min': -1, 'max': 1 });
    setprop("/Arduino/controls/flight/rudder", 0);
}

var AFGaileron = func() {
    var increment = 1;
    var change = getprop("/Arduino/controls/flight/aileron");
    if (change == 0)
        return;

    fgcommand("property-adjust", {'property': '/controls/flight/aileron', 'step': increment*change, 'min': -1, 'max': 1 });
    setprop("/Arduino/controls/flight/aileron", 0);
}

var AFGelevator = func() {
    var increment = 1;
    var change = getprop("/Arduino/controls/flight/elevator");
    if (change == 0)
        return;

    fgcommand("property-adjust", {'property': '/controls/flight/elevator', 'step': increment*change, 'min': -1, 'max': 1 });
    setprop("/Arduino/controls/flight/elevator", 0);
}

var AFGelevatortrim = func() {
    var increment = 1;
    var change = getprop("/Arduino/controls/flight/elevator-trim");
    if (change == 0)
        return;

    fgcommand("property-adjust", {'property': '/controls/flight/elevator-trim', 'step': increment*change, 'min': -1, 'max': 1 });
    setprop("/Arduino/controls/flight/elevator-trim", 0);
}

append(afg.enc, setlistener("/Arduino/controls/flight/rudder", AFGrudder, 0, 0) );
append(afg.enc, setlistener("/Arduino/controls/flight/aileron", AFGaileron, 0, 0) );
append(afg.enc, setlistener("/Arduino/controls/flight/elevator", AFGelevator, 0, 0) );
append(afg.enc, setlistener("/Arduino/controls/flight/elevator-trim", AFGelevatortrim, 0, 0) );



var printlisteners = func(arr, str) {
    print(str);
    for(var i=0; i<size(arr); i=i+1) {
        print(arr[i]);
    }
}

printlisteners(afg.ap, "AFG Autopilot listeners:");
printlisteners(afg.adf, "AFG ADF listeners:");
printlisteners(afg.enc, "AFG encoder listeners:");


