//pushbuttons.cpp

#include "afgcockpit.h"
#include "pushbuttons.h"


#if NPUSHBUTTONS > 0



void setupPushButtons() {
  // initialize the pushbutton pin as an input:
  for (int i=0; i<NPUSHBUTTONS; i++) {
    pushbuttons[i].pin = pushbutton_pins[i];
    pinMode(pushbuttons[i].pin, INPUT);
  }

}

void readPushButtons() {
  // Read and update values for all pushbuttons:
  for (int i=0; i<NPUSHBUTTONS; i++)
    readPushButton(&pushbuttons[i]);
}

void readPushButton(PushButton *btn) {

  // Avoid bouncing by checking that a certain time has passed
  // since last check:
  if (btn->timer + button_debounce_delay > millis())
    return;

  int current_state = digitalRead(btn->pin);

  if (btn->state != current_state) {
    // Change in state, from HIGH->LOW or LOW->HIGH has occurred.
    btn->state = current_state;
    btn->timer = millis();
    sendmsg = true;
  }
}

void printPushButtons() {
  for (int i=0; i<NPUSHBUTTONS; i++) {
    Serial.print(pushbuttons[i].state);
    Serial.print(",");
  }

}

#endif
